//+------------------------------------------------------------------
//|                         pretty good oscillator Tim Moris smoothed
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_level1  0
#property indicator_levelcolor DimGray

//
//
//
//
//

extern int    Price       = PRICE_CLOSE;
extern int    Length      = 89;
extern double TmSmoothing =  5;
extern double TmDamping   =  5;
extern double TmNoise     =  2;

//
//
//
//
//

double pgo[];
double pgoDa[];
double pgoDb[];
double slope[];

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
      SetIndexBuffer(0,pgo);
      SetIndexBuffer(1,pgoDa);
      SetIndexBuffer(2,pgoDb);
      SetIndexBuffer(3,slope);
   IndicatorShortName("pgo tm smoothed ("+Length+")");      
   return (0);
}
int deinit() { return (0); }

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double work[];

//
//
//
//
//

int start()
{
   double alphaAtr = 2.0/(1.0+Length);   
   int i,r,limit,counted_bars = IndicatorCounted();

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (ArraySize(work)!=Bars) ArrayResize(work,Bars);

   //
   //
   //
   //
   //

      if (slope[limit]==-1) CleanPoint(limit,pgoDa,pgoDb);
      for (i = limit, r=Bars-i-1; i >= 0; i--, r++)
      {
         work[r]  = work[r-1] + alphaAtr*(MathMax(High[i],Close[i+1])-MathMin(Low[i],Close[i+1])-work[r-1]);
         pgo[i]   = iTmSmooth((iMA(NULL,0,1,0,MODE_SMA,Price,i)-iMA(NULL,0,Length,0,MODE_SMA,Price,i))/work[r],TmDamping,TmNoise,TmSmoothing,i);
         pgoDa[i] = EMPTY_VALUE;
         pgoDb[i] = EMPTY_VALUE;
         slope[i] = slope[i+1];
            if (pgo[i] > pgo[i+1]) slope[i] =  1;
            if (pgo[i] < pgo[i+1]) slope[i] = -1;
            if (slope[i] == -1) PlotPoint(i,pgoDa,pgoDb,pgo);
      }

   //
   //
   //
   //
   //
   
   return (0);
}

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i]   = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//

double wrkTm[][3];
#define _price 0
#define _y1    1
#define _y2    2

//
//
//
//
//

double iTmSmooth(double price, double damping, double noise, double length, int i)
{
   if (ArrayRange(wrkTm,0) != Bars) ArrayResize(wrkTm,Bars);
   if (length<=1) return(price);
      int r = Bars-i-1;

   //
   //
   //
   //
   //

      wrkTm[r][_price] = price;

         double y1 = wrkTm[r-1][_y1];
         double y2 = wrkTm[r-1][_y2];
         
         double err = (wrkTm[r][_price]-2.0*y1+y2)/noise; 
         double drv = MathMax(MathMin((1.0/length)*err*err+(1.0/length)*MathAbs(err),0.5),0.0);
         double dmp = MathMax(MathMin((1.0/length)*MathAbs(y1-y2)/noise + damping/100.0,1.0),0.0);
         
         //
         //
         //
         //
         //
         
      double tmAvg  = y1 + noise*err*drv + (y1-y2)*(1.0-dmp);
      wrkTm[r][_y1] = tmAvg;
      wrkTm[r][_y2] = y1;
      return(tmAvg);
}